package com.yidianling.home.ui.view

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Typeface
import android.media.MediaPlayer
import android.text.SpannableString
import android.text.Spanned
import android.text.style.StyleSpan
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import androidx.recyclerview.widget.RecyclerView
import com.google.android.material.tabs.TabLayout
import com.google.android.material.tabs.TabLayoutMediator
import com.google.gson.Gson
import com.ydl.ydl_image.module.GlideApp
import com.yidianling.home.MeditationViewPagerAdapter
import com.yidianling.home.R
import com.yidianling.home.constract.HomeViewConfig
import com.yidianling.home.event.IHomeEvent
import com.yidianling.home.model.MeditationTypeModel
import com.yidianling.home.model.bean.MuseModuleBean
import kotlinx.android.synthetic.ydl.home_muse_view.view.*

/**
 * @author <a href="https://www.jianshu.com/u/c1e5310dd724">xujian</a>
 * @描述: 冥想模块
 * @Copyright Copyright (c) 2019
 * @Company 壹点灵
 * @date 2019/09/10
 */
class HomeMuseView(private val mContext: Context, private var homeEvent: IHomeEvent?) :
    LinearLayout(mContext) {

    private var cacheList: ArrayList<HomeMuseView> = ArrayList()

    private val meditationTitles = arrayOf("睡眠","冥想","治愈")

    init {
        initView()
    }

    @SuppressLint("RestrictedApi")
    private fun initView() {
        orientation = VERTICAL
        val params = RecyclerView.LayoutParams(
            ViewGroup.LayoutParams.MATCH_PARENT,
            ViewGroup.LayoutParams.WRAP_CONTENT
        )
        layoutParams = params
        View.inflate(mContext, R.layout.home_muse_view, this)
        homeModuleMuseViewHomeCommonTitleView.setTitle(HomeViewConfig.getOrder().museTitle)
    }

    fun initData(bean: MuseModuleBean?) {

        if (null != bean) {

            var dataJson = Gson().toJson(bean)
            homeModuleMuseViewHomeCommonTitleView.setOnClickListener {
                homeEvent?.museMoreClick(Gson().toJson(bean))
            }

            if (null != bean.muses) {
                if (bean.muses?.size!! > 0) {
                    muse_first.setOnClickListener {
                        homeEvent?.museClick(bean.muses!![0].audioUrl, dataJson,muse_first_text.text.toString())
                    }
                }
                if (bean.muses?.size!! > 1) {
                    muse_second.setOnClickListener {
                        homeEvent?.museClick(bean.muses!![1].audioUrl, dataJson,muse_second_text.text.toString())
                    }
                }
                if (bean.muses?.size!! > 2) {
                    muse_third.setOnClickListener {
                        homeEvent?.museClick(bean.muses!![2].audioUrl, dataJson,muse_third_text.text.toString())
                    }
                }
                if (bean.muses?.size!! > 3) {
                    muse_forth.setOnClickListener {
                        homeEvent?.museClick(bean.muses!![3].audioUrl, dataJson,muse_forth_text.text.toString())
                    }
                }
            }
            if (null != bean.sleeps) {
                if (bean.sleeps?.size!! > 0) {
                    sleeps_first.setOnClickListener {
                        homeEvent?.museClick(bean.sleeps!![0].audioUrl, dataJson,sleeps_first_text.text.toString())
                    }
                }
                if (bean.sleeps?.size!! > 1) {
                    sleeps_second.setOnClickListener {
                        homeEvent?.museClick(bean.sleeps!![1].audioUrl, dataJson,sleeps_second_text.toString())
                    }
                }
                if (bean.sleeps?.size!! > 2) {
                    sleeps_third.setOnClickListener {
                        homeEvent?.museClick(bean.sleeps!![2].audioUrl, dataJson,sleeps_third_text.text.toString())
                    }
                }
                if (bean.sleeps?.size!! > 3) {
                    sleeps_forth.setOnClickListener {
                        homeEvent?.museClick(bean.sleeps!![3].audioUrl, dataJson,sleeps_forth_text.text.toString())
                    }
                }
            }

            GlideApp.with(this)
                .load("http://clips.vorwaerts-gmbh.de/big_buck_bunny.mp4")
                .into(iv_video_background)

            video_view?.setVideoPath("http://clips.vorwaerts-gmbh.de/big_buck_bunny.mp4")

            video_view?.setOnPreparedListener {
                it?.setVideoScalingMode(MediaPlayer.VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING)
                video_view?.setOnInfoListener { mp, what, extra ->
                    if (what == MediaPlayer.MEDIA_INFO_VIDEO_RENDERING_START){
                        iv_video_background.visibility = GONE
                    }
                    true
                }
                it?.start()
                it?.setVolume(0.0F,0.0F)
            }
            video_view?.setOnCompletionListener { video_view?.start() }


            val data = mutableListOf<List<MeditationTypeModel>>()

            val innerData = mutableListOf<MeditationTypeModel>()

            for (i in 0 until 4){
                val name = when(i){
                    0 -> "溪流"
                    1 -> "田园"
                    2 -> "雨声"
                    else -> "更多"
                }
                val imageUrl = when(i){
                    0 -> "https://img0.baidu.com/it/u=2451025451,2376393604&fm=253&fmt=auto&app=138&f=JPEG?w=499&h=328"
                    1 -> "https://gimg2.baidu.com/image_search/src=http%3A%2F%2Fimg.9ku.com%2Fgeshoutuji%2Fsingertuji%2F4%2F40945%2F40945_1.jpg&refer=http%3A%2F%2Fimg.9ku.com&app=2002&size=f9999,10000&q=a80&n=0&g=0n&fmt=auto?sec=1654863419&t=aaea1ecc66afc7859a0cf64c06c6f2a4"
                    2 -> "https://img2.baidu.com/it/u=3357363842,3633429992&fm=253&fmt=auto&app=138&f=JPEG?w=500&h=740"
                    else -> "https://img2.baidu.com/it/u=3357363842,3633429992&fm=253&fmt=auto&app=138&f=JPEG?w=500&h=740"
                }
                val isMore = i == 3
                innerData.add(MeditationTypeModel(imageUrl,name,i.toString(),isMore))
            }

            for (i in 0 until 3){
                data.add(innerData)
            }


            view_pager.adapter = MeditationViewPagerAdapter(
                mContext,data)

            tab_layout.addOnTabSelectedListener(object :TabLayout.OnTabSelectedListener{
                override fun onTabSelected(tab: TabLayout.Tab?) {
                    var text:String? = tab?.text.toString().trim() ?: return
                    val spStr = SpannableString(text)
                    val styleSpan = StyleSpan(Typeface.BOLD)
                    spStr.setSpan(styleSpan,0,text?.length?:0,Spanned.SPAN_INCLUSIVE_EXCLUSIVE)
                    tab?.text = spStr
                }

                override fun onTabUnselected(tab: TabLayout.Tab?) {
                    var text:String? = tab?.text.toString().trim() ?: return
                    val spStr = SpannableString(text)
                    val styleSpan = StyleSpan(Typeface.NORMAL)
                    spStr.setSpan(styleSpan,0,text?.length?:0,Spanned.SPAN_INCLUSIVE_EXCLUSIVE)
                    tab?.text = spStr
                }

                override fun onTabReselected(tab: TabLayout.Tab?) {

                }

            })

            TabLayoutMediator(tab_layout,view_pager){
                tab, position ->
                    tab.text = meditationTitles[position]
            }.attach()


        }
    }

}